
! By Chris Antonopoulos

program FPUb_LEs_si_Yoshida
implicit none

real(kind=8),external		:: solved_hamiltonian_function, kinetic_energy_function, potential_energy_function, kinetic_energy_derivative_function, potential_energy_derivative_function
real(kind=8),allocatable	:: q(:), qnorm(:), suma(:), LEs(:), array_nrg(:)
real(kind=8)				:: t, t0, tf, tstep
real(kind=8)				:: relative_energy_error, hamiltonianenergy, hamiltonianenergy_q
real(kind=8)				:: initial_energy_TDH, relative_energy_error_TDH
real(kind=8)				:: beta, nmax, ii, c, c_neighbor, perturbation, IcLE, maxdK_dt, dK_dt, H_KS_entropy, sum_time_average_abs_dk_dt_over_LE1_Ham_vs_nrg, sum_time_average_abs_dk_over_LE1_Ham_vs_nrg
real(kind=8)				:: kappa_modulus2, solutionkappamodulus1, solutionkappamodulus2, solutionkappamodulus3, solutionkappamodulus4
real(kind=8)				:: min_nrg, max_nrg, number_of_steps_nrg
real(kind=8)				:: kinetic_energy_old, potential_energy_old
real(kind=4)				:: time_begin
integer(kind=4)				:: ndof, ndof2, si, i, j, index
integer(kind=4)				:: numfile_info, numfile_rel_ham_err, numfile_Lyap_exps, numfile_LEs_plot_gnu, numfile_IcLE_and_maxdK_dt_vs_nrg, numfile_IcLE_and_maxdK_dt_vs_nrg_gnu
integer(kind=4)				:: min_number_of_nrg, max_number_of_nrg
integer(kind=4)				:: multiple, numberofdeviationvectors
character(*)				:: filename_input_parameters
parameter(filename_input_parameters='input.in')
character(26)				:: char_numfile_Lyap_exps
character*(*)				:: file_name_LE
parameter(file_name_LE='fpu_LE')
character*(*)				:: file_name_output
parameter(file_name_output='')
character(1)				:: char_ndof_1
character(2)				:: char_ndof_2
character(3)				:: char_ndof_3
character(6)				:: char_nrg_1
character(7)				:: char_nrg_2
character(8)				:: char_nrg_3
common /param1/ beta
common /param2/ hamiltonianenergy

call cpu_time(time_begin)

call read_input_parameters(perturbation,t0,tf,tstep,beta,si,ndof,numberofdeviationvectors,numfile_info,numfile_rel_ham_err,numfile_Lyap_exps,filename_input_parameters,numfile_LEs_plot_gnu,numfile_IcLE_and_maxdK_dt_vs_nrg,numfile_IcLE_and_maxdK_dt_vs_nrg_gnu)

nmax=(tf-t0)/tstep	;	t=t0

ndof2=2*ndof

! for ndof=14 (degrees of freedom), the SPO2 is destabilized at the energy Ec=0.1174068938024310
! for ndof=14 (degrees of freedom), the SPO2 is restabilized again at the energy Ec=47.0586339238576130
min_number_of_nrg=30	;	max_number_of_nrg=111
allocate(array_nrg(min_number_of_nrg:max_number_of_nrg))
hamiltonianenergy=29.75d0
do i=min_number_of_nrg,max_number_of_nrg
	hamiltonianenergy=hamiltonianenergy+0.25d0
	array_nrg(i)=hamiltonianenergy
!	write(*,*) i, array_nrg(i)
enddo

call systemqq("mkdir -p results")

open(numfile_IcLE_and_maxdK_dt_vs_nrg,file='IcLE_and_maxdK_dt_vs_nrg.out',status='replace')

nrg_loop: do j=min_number_of_nrg,max_number_of_nrg
!nrg_loop: do j=min_number_of_nrg,max_number_of_nrg
	call cpu_time(time_begin)
	hamiltonianenergy=array_nrg(j)

	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	if ((0.d0<=hamiltonianenergy).and.(hamiltonianenergy<10.d0)) then
		write(char_nrg_1,'(f6.3)') hamiltonianenergy
		if ((1<=ndof).and.(ndof<=9)) then
			write(char_ndof_1,'(i1)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_1//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_1//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_1,char_nrg_1)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
		endif
		if ((10<=ndof).and.(ndof<=99)) then
			write(char_ndof_2,'(i2)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_2//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_1//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_2,char_nrg_1)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
		endif
		if ((100<=ndof).and.(ndof<=999)) then
			write(char_ndof_3,'(i3)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_3//'_nrg='//char_nrg_1//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_1//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_3,char_nrg_1)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
		endif
	endif
	if ((10.d0<=hamiltonianenergy).and.(hamiltonianenergy<100.d0)) then
		write(char_nrg_2,'(f7.3)') hamiltonianenergy
		if ((1<=ndof).and.(ndof<=9)) then
			write(char_ndof_1,'(i1)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_1//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_2//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_1,char_nrg_2)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
		endif
		if ((10<=ndof).and.(ndof<=99)) then
			write(char_ndof_2,'(i2)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_2//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_2//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_2,char_nrg_2)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
		endif
		if ((100<=ndof).and.(ndof<=999)) then
			write(char_ndof_3,'(i3)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_3//'_nrg='//char_nrg_2//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_2//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_3,char_nrg_2)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
		endif
	endif
	if ((100.d0<=hamiltonianenergy).and.(hamiltonianenergy<1000.d0)) then
		write(char_nrg_3,'(f8.3)') hamiltonianenergy
		if ((1<=ndof).and.(ndof<=9)) then
			write(char_ndof_1,'(i1)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_1//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_3//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_1,char_nrg_3)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
		endif
		if ((10<=ndof).and.(ndof<=99)) then
			write(char_ndof_2,'(i2)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_2//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_3//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_2,char_nrg_3)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
		endif
		if ((100<=ndof).and.(ndof<=999)) then
			write(char_ndof_3,'(i3)') ndof
			open(numfile_info,file=file_name_output//file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_rel_ham_err,file=file_name_output//file_name_LE//'_relative_energy_error_'//char_ndof_3//'_nrg='//char_nrg_3//'.txt',status='replace')
			open(numfile_Lyap_exps,file=file_name_output//file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_3//'.txt',status='replace')
			call LEs_plot_gnu_file(numfile_LEs_plot_gnu,char_ndof_3,char_nrg_3)
			call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"'")
			call systemqq("mkdir -p 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
		endif
	endif
	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	allocate(q((1+numberofdeviationvectors)*ndof2),qnorm(numberofdeviationvectors),suma(numberofdeviationvectors),LEs(numberofdeviationvectors))
	q=0.d0	;	qnorm=0.d0	;	suma=0.d0	;	LEs=0.d0

	write(numfile_info,'(/,15x,"Lyapunov exponents for the FPU-beta FBC anharmonic oscillator lattice (SPO2)",/)')
	write(*,'(/,15x,"Lyapunov exponents for the FPU-beta FBC anharmonic oscillator lattice (SPO2)",/)')

	! definition of initial condition of the SPO2 is here
	solutionkappamodulus1=-(dsqrt((1.d0 + ndof + 6.d0*beta*hamiltonianenergy - dsqrt((1.d0 + ndof)*(1.d0 + ndof + 6.d0*beta*hamiltonianenergy)))/(1.d0 + ndof + 6.d0*beta*hamiltonianenergy))/dsqrt(2.d0))
	solutionkappamodulus2=dsqrt((1.d0 + ndof + 6.d0*beta*hamiltonianenergy - dsqrt((1.d0 + ndof)*(1.d0 + ndof + 6.d0*beta*hamiltonianenergy)))/(1.d0 + ndof + 6.d0*beta*hamiltonianenergy))/dsqrt(2.d0)
	solutionkappamodulus3=-(dsqrt((1.d0 + ndof + 6.d0*beta*hamiltonianenergy + dsqrt((1.d0 + ndof)*(1.d0 + ndof + 6.d0*beta*hamiltonianenergy)))/(1.d0 + ndof + 6.d0*beta*hamiltonianenergy))/dsqrt(2.d0))
	solutionkappamodulus4=dsqrt((1.d0 + ndof + 6.d0*beta*hamiltonianenergy + dsqrt((1.d0 + ndof)*(1.d0 + ndof + 6.d0*beta*hamiltonianenergy)))/(1.d0 + ndof + 6.d0*beta*hamiltonianenergy))/dsqrt(2.d0)

	if ((solutionkappamodulus1>=0.d0).and.(solutionkappamodulus1<=1.d0/dsqrt(2.d0))) then
		kappa_modulus2=solutionkappamodulus1**2
		write(*,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus1 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
		write(numfile_info,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus1 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
	endif
	if ((solutionkappamodulus2>=0.d0).and.(solutionkappamodulus2<=1.d0/dsqrt(2.d0))) then
		kappa_modulus2=solutionkappamodulus2**2
		write(*,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus2 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
		write(numfile_info,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus2 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
	endif
	if ((solutionkappamodulus3>=0.d0).and.(solutionkappamodulus3<=1.d0/dsqrt(2.d0))) then
		kappa_modulus2=solutionkappamodulus3**2
		write(*,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus3 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
		write(numfile_info,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus3 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
	endif
	if ((solutionkappamodulus4>=0.d0).and.(solutionkappamodulus4<=1.d0/dsqrt(2.d0))) then
		kappa_modulus2=solutionkappamodulus4**2
		write(*,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus4 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
		write(numfile_info,'(1x,"kappa_modulus**2=",1x,f20.10,1x," ==> solutionkappamodulus4 and energy=",1x,f20.10)') kappa_modulus2, hamiltonianenergy
	endif
	c=(dsqrt(-1.d0 + 1.d0/(1.d0 - 2.d0*kappa_modulus2))/(dsqrt(3.d0)*dsqrt(beta)))
	write(numfile_info,*)
	write(*,*)

	c_neighbor=c-perturbation
	do i=2,ndof-3,3
		q(i)=c_neighbor
		q(i+3)=c_neighbor
	enddo
	do i=1,ndof-1,3
		q(i)=c_neighbor
		q(i+1)=-c_neighbor
	enddo
	do i=ndof+1,2*ndof
		q(i)=0.d0
	enddo
	if (solved_hamiltonian_function((1+numberofdeviationvectors)*ndof2,q)>=0.d0) then
		q(ndof2)=dsqrt(solved_hamiltonian_function((1+numberofdeviationvectors)*ndof2,q))
	else
		write(*,'(1x,"q(",i2,")<0!")') ndof2
		write(numfile_info,'(1x,"q(",i2,")<0!")') ndof2
		stop
	endif
	! q(1:ndof2) is now the neighboring of the SPO2 initial condition and not the SPO anymore as it was just above
	! q(1:ndof2) is the reference orbit for which we compute the Lyapunov exponents using the variational equations

	call Hamiltonian_function((1+numberofdeviationvectors)*ndof2,q,hamiltonianenergy_q)
	write(*,'(" Hamiltonian energy of initial condition q=",f26.16)') hamiltonianenergy_q
	write(numfile_info,'(" Hamiltonian energy of initial condition q=",f26.16)') hamiltonianenergy_q

	relative_energy_error=dabs(hamiltonianenergy_q-hamiltonianenergy)/hamiltonianenergy

	! initial conditions for the deviation vectors according to the usual orthonormal basis of R^N
	do index=1,numberofdeviationvectors
		q(index*(ndof2+1))=1.d0
	enddo

	write(numfile_info,'(" Number of degrees of freedom= ",i8)') ndof
	write(numfile_info,'(" Order of symplectic integrator= ",i1)') si
	write(numfile_info,'(" Initial time= ",f26.16)') t0
	write(numfile_info,'(" Final time= ",es26.16)') tf
	write(numfile_info,'(" Time step of the symplectic integrator= ",es26.16)') tstep
	write(numfile_info,'(" Number of time units= ",es26.16)') nmax
	write(numfile_info,'(" Hamiltonian energy= ",f26.16)') hamiltonianenergy
	write(numfile_info,'(" Energy density= ",f26.16)') hamiltonianenergy/ndof
	write(numfile_info,'(" beta= ",f26.16)') beta
	write(numfile_info,'(" Number of deviation vectors= ",i5)') numberofdeviationvectors
	write(numfile_info,'(" Perturbation of the initial conditions= ",es26.16)') perturbation
	write(numfile_rel_ham_err,'(/,"Current time/ Final time",9x,"Computed energy",7x,"Relative energy error")')
	write(numfile_rel_ham_err,'(es11.4," /",es11.4,f26.16,9x,es11.4)') t, tf, hamiltonianenergy_q, relative_energy_error

	write(*,'(" Number of degrees of freedom= ",i8)') ndof
	write(*,'(" Order of symplectic integrator= ",i1)') si
	write(*,'(" Initial time= ",f26.16)') t0
	write(*,'(" Final time= ",es26.16)') tf
	write(*,'(" Time step of the symplectic integrator= ",es26.16)') tstep
	write(*,'(" Number of time units= ",es26.16)') nmax
	write(*,'(" Hamiltonian energy= ",f26.16)') hamiltonianenergy
	write(*,'(" Energy density= ",f26.16)') hamiltonianenergy/ndof
	write(*,'(" beta= ",f26.16)') beta
	write(*,'(" Number of deviation vectors= ",i5)') numberofdeviationvectors
	write(*,'(" Perturbation of the initial conditions= ",es26.16)') perturbation
	write(*,'(/,"Current time/ Final time",9x,"Computed energy",7x,"Relative energy error")')
	write(*,'(es11.4," /",es11.4,f26.16,9x,es11.4)') t, tf, hamiltonianenergy_q, relative_energy_error

	ii=0.d0	;	multiple=0

	maxdK_dt=-huge(1.d0)

	sum_time_average_abs_dk_over_LE1_Ham_vs_nrg=0.d0
	sum_time_average_abs_dk_dt_over_LE1_Ham_vs_nrg=0.d0

	do while (ii<nmax)
		kinetic_energy_old=kinetic_energy_function(q,ndof2)
		potential_energy_old=potential_energy_function(q,ndof2)

		select case (si)
		case(1)
			call si_mapping_1st_order(ndof2,numberofdeviationvectors,q,tstep)
		case(2)
			call si_mapping_2nd_order(ndof2,numberofdeviationvectors,q,tstep)
		case(3)
			call si_mapping_3rd_order(ndof2,numberofdeviationvectors,q,tstep)
		case(4)
			call si_mapping_4th_order(ndof2,numberofdeviationvectors,q,tstep)
		case(6)
			call si_mapping_6th_order(ndof2,numberofdeviationvectors,q,tstep)
		case(8)
			call si_mapping_8th_order(ndof2,numberofdeviationvectors,q,tstep)
		case default
			write(*,'(/,/," Wrong number for the order of the symplectic integrator",/,/)')
			write(*,'(" It should be either 1, 2, 3, 4, 6 or 8.",/,/)')
			write(numfile_info,'(/,/," Wrong number for the order of the symplectic integrator",/,/)')
			write(numfile_info,'(" It should be either 1, 2, 3, 4, 6 or 8.",/,/)')
			stop
		end select

		ii=ii+1.d0
		t=t0+ii*tstep

		dK_dt=kinetic_energy_derivative_function(q,ndof2)
		if (dK_dt>maxdK_dt) maxdK_dt=dK_dt

		sum_time_average_abs_dk_over_LE1_Ham_vs_nrg=sum_time_average_abs_dk_over_LE1_Ham_vs_nrg+dabs(kinetic_energy_function(q,ndof2)-kinetic_energy_old)
		sum_time_average_abs_dk_dt_over_LE1_Ham_vs_nrg=sum_time_average_abs_dk_dt_over_LE1_Ham_vs_nrg+dabs(dK_dt)

		call Gram_Schmidt_orthogonormalization(ndof2,numberofdeviationvectors,q,qnorm)
		call Lyapunov_exponents(numberofdeviationvectors,qnorm,suma,t,LEs)

		if (dabs(t-10.d0**(1.d0+multiple*.05d0))<=tstep.or.t>=tf) then
			call Hamiltonian_function((1+numberofdeviationvectors)*ndof2,q,hamiltonianenergy_q)
			relative_energy_error=dabs(hamiltonianenergy_q-hamiltonianenergy)/hamiltonianenergy
			write(*,'(es11.4," /",es11.4,f26.16,9x,es11.4)') t, tf, hamiltonianenergy_q, relative_energy_error
			write(numfile_rel_ham_err,'(es11.4," /",es11.4,f26.16,9x,es11.4)') t, tf, hamiltonianenergy_q, relative_energy_error
			call flush(numfile_rel_ham_err)
			if (numberofdeviationvectors==ndof2) then
				write(numfile_Lyap_exps,'(es26.16,<numberofdeviationvectors>f26.16,es26.16)') t, (LEs(index),index=1,numberofdeviationvectors), dabs(sum(LEs))
				call flush(numfile_Lyap_exps)
			else
				write(numfile_Lyap_exps,'(es26.16,<numberofdeviationvectors>f26.16,f26.16)') t, (LEs(index),index=1,numberofdeviationvectors), sum(LEs(1:numberofdeviationvectors))
				call flush(numfile_Lyap_exps)
			endif
			multiple=multiple+1
		endif
 	enddo ! end of time loop

	close(numfile_rel_ham_err)
	close(numfile_Lyap_exps)

	sum_time_average_abs_dk_over_LE1_Ham_vs_nrg=sum_time_average_abs_dk_over_LE1_Ham_vs_nrg/t
	sum_time_average_abs_dk_dt_over_LE1_Ham_vs_nrg=sum_time_average_abs_dk_dt_over_LE1_Ham_vs_nrg/t

	IcLE=2.d0*sum(LEs(1:int(numberofdeviationvectors/2)))-sum(LEs(1:numberofdeviationvectors))
	H_KS_entropy=sum(LEs(1:numberofdeviationvectors))
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	write(numfile_IcLE_and_maxdK_dt_vs_nrg,'(es26.16,4f26.16,2es26.16,f26.16)') t, hamiltonianenergy, maxdK_dt, IcLE, H_KS_entropy, sum_time_average_abs_dk_dt_over_LE1_Ham_vs_nrg/LEs(1), sum_time_average_abs_dk_over_LE1_Ham_vs_nrg/LEs(1), LEs(1)
	call flush(numfile_IcLE_and_maxdK_dt_vs_nrg)
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	deallocate(q,qnorm,suma,LEs)

	call write_used_time(numfile_info,time_begin)
	close(numfile_info)

	if ((0.d0<=hamiltonianenergy).and.(hamiltonianenergy<10.d0)) then
		write(char_nrg_1,'(f6.3)') hamiltonianenergy
		if ((1<=ndof).and.(ndof<=9)) then
			write(char_ndof_1,'(i1)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_1//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_1//'_nrg='//char_nrg_1//".gnu' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'")
			call systemqq("cd 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_1//"'; gnuplot < 'LEs_plot_"//char_ndof_1//"_nrg="//char_nrg_1//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
		if ((10<=ndof).and.(ndof<=99)) then
			write(char_ndof_2,'(i2)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_2//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_2//'_nrg='//char_nrg_1//".gnu' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'")
			call systemqq("cd 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_1//"'; gnuplot < 'LEs_plot_"//char_ndof_2//"_nrg="//char_nrg_1//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
		if ((100<=ndof).and.(ndof<=999)) then
			write(char_ndof_3,'(i3)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_3//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_1//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_3//'_nrg='//char_nrg_1//".gnu' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'")
			call systemqq("cd 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_1//"'; gnuplot < 'LEs_plot_"//char_ndof_3//"_nrg="//char_nrg_1//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
	endif
	if ((10.d0<=hamiltonianenergy).and.(hamiltonianenergy<100.d0)) then
		write(char_nrg_2,'(f7.3)') hamiltonianenergy
		if ((1<=ndof).and.(ndof<=9)) then
			write(char_ndof_1,'(i1)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_1//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_1//'_nrg='//char_nrg_2//".gnu' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'")
			call systemqq("cd 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_2//"'; gnuplot < 'LEs_plot_"//char_ndof_1//"_nrg="//char_nrg_2//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
		if ((10<=ndof).and.(ndof<=99)) then
			write(char_ndof_2,'(i2)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_2//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_2//'_nrg='//char_nrg_2//".gnu' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'")
			call systemqq("cd 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_2//"'; gnuplot < 'LEs_plot_"//char_ndof_2//"_nrg="//char_nrg_2//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
		if ((100<=ndof).and.(ndof<=999)) then
			write(char_ndof_3,'(i3)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_3//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_2//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_3//'_nrg='//char_nrg_2//".gnu' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'")
			call systemqq("cd 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_2//"'; gnuplot < 'LEs_plot_"//char_ndof_3//"_nrg="//char_nrg_2//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
	endif
	if ((100.d0<=hamiltonianenergy).and.(hamiltonianenergy<1000.d0)) then
		write(char_nrg_3,'(f8.3)') hamiltonianenergy
		if ((1<=ndof).and.(ndof<=9)) then
			write(char_ndof_1,'(i1)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_1//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_1//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_1//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_1//'_nrg='//char_nrg_3//".gnu' 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'")
			call systemqq("cd 'results/ndof="//char_ndof_1//"/nrg="//char_nrg_3//"'; gnuplot < 'LEs_plot_"//char_ndof_1//"_nrg="//char_nrg_3//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
		if ((10<=ndof).and.(ndof<=99)) then
			write(char_ndof_2,'(i2)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_2//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_2//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_2//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_2//'_nrg='//char_nrg_3//".gnu' 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'")
			call systemqq("cd 'results/ndof="//char_ndof_2//"/nrg="//char_nrg_3//"'; gnuplot < 'LEs_plot_"//char_ndof_2//"_nrg="//char_nrg_3//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
		if ((100<=ndof).and.(ndof<=999)) then
			write(char_ndof_3,'(i3)') ndof
			call systemqq("mv '"//file_name_LE//'_'//char_ndof_3//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
			call systemqq("mv '"//file_name_LE//'_relative_energy_error_'//char_ndof_3//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
			call systemqq("mv '"//file_name_LE//'_data_'//char_ndof_3//'_nrg='//char_nrg_3//".txt' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
			call systemqq("mv 'LEs_plot_"//char_ndof_3//'_nrg='//char_nrg_3//".gnu' 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'")
			call systemqq("cd 'results/ndof="//char_ndof_3//"/nrg="//char_nrg_3//"'; gnuplot < 'LEs_plot_"//char_ndof_3//"_nrg="//char_nrg_3//".gnu' 2> gnuplot_output.tmp; rm -rf gnuplot_output.tmp")
		endif
	endif
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	call IcLE_and_maxdK_dt_vs_nrg_plot_gnu_file(numfile_IcLE_and_maxdK_dt_vs_nrg_gnu)
	call systemqq("gnuplot < IcLE_and_maxdK_dt_vs_nrg_plot.gnu")
enddo nrg_loop
close(numfile_IcLE_and_maxdK_dt_vs_nrg)

call systemqq("gnuplot < IcLE_and_maxdK_dt_vs_nrg_plot.gnu")
call systemqq("mv IcLE_and_maxdK_dt_vs_nrg*.* 'results/'")

deallocate(array_nrg)

end program FPUb_LEs_si_Yoshida
